// SPDX-License-Identifier: LGPL-2.1-only OR LGPL-3.0-only OR LicenseRef-KDE-Accepted-LGPL
// SPDX-FileCopyrightText: 2024 Arjen Hiemstra <ahiemstra@heimr.nl>
//
// This file is automatically generated from qml_group.h.j2.
// To regenerate, run `tools/propertygenerator/generate_properties.py`.

#pragma once

// clang-format off
#include <QJSValue>
#include <QObject>
#include <QProperty>
#include <qqmlregistration.h>


#include <properties/BackgroundProperty.h>

#include "ImagePropertyGroup.h"
#include "BorderPropertyGroup.h"
#include "CornersPropertyGroup.h"
#include "ShadowPropertyGroup.h"
// clang-format on

class QuickStyle;

/*!
 * \qmltype BackgroundPropertyGroup
 * \inqmlmodule org.kde.union.impl
 * \ingroup qtquick-properties
 *
 * \brief A group object exposing the properties of BackgroundProperty to QML.
 */
class BackgroundPropertyGroup : public QObject
{
    Q_OBJECT
    QML_ANONYMOUS

public:
    explicit BackgroundPropertyGroup(QuickStyle *style);

    void update(const Union::Properties::BackgroundProperty &newState);
    Q_SIGNAL void updated();

    /*!
     * \qmlproperty QColor BackgroundPropertyGroup::color
     *
     * Exposes BackgroundProperty::color to QML.
     */
    Q_PROPERTY(QJSValue color READ color NOTIFY colorChanged)
    QJSValue color() const;
    Q_SIGNAL void colorChanged();

    /*!
     * \qmlproperty ImagePropertyGroup BackgroundPropertyGroup::image
     *
     * Exposes BackgroundProperty::ImageProperty to QML.
     */
    Q_PROPERTY(ImagePropertyGroup *image READ image CONSTANT)
    ImagePropertyGroup *image() const;

    /*!
     * \qmlproperty BorderPropertyGroup BackgroundPropertyGroup::border
     *
     * Exposes BackgroundProperty::BorderProperty to QML.
     */
    Q_PROPERTY(BorderPropertyGroup *border READ border CONSTANT)
    BorderPropertyGroup *border() const;

    /*!
     * \qmlproperty CornersPropertyGroup BackgroundPropertyGroup::corners
     *
     * Exposes BackgroundProperty::CornersProperty to QML.
     */
    Q_PROPERTY(CornersPropertyGroup *corners READ corners CONSTANT)
    CornersPropertyGroup *corners() const;

    /*!
     * \qmlproperty ShadowPropertyGroup BackgroundPropertyGroup::shadow
     *
     * Exposes BackgroundProperty::ShadowProperty to QML.
     */
    Q_PROPERTY(ShadowPropertyGroup *shadow READ shadow CONSTANT)
    ShadowPropertyGroup *shadow() const;

private:
    QuickStyle *m_style = nullptr;
    std::unique_ptr<ImagePropertyGroup> m_image;
    std::unique_ptr<BorderPropertyGroup> m_border;
    std::unique_ptr<CornersPropertyGroup> m_corners;
    std::unique_ptr<ShadowPropertyGroup> m_shadow;
    Union::Properties::BackgroundProperty m_state;
};